debootstrap from an ISO when ISO is set as MIRROR is always set
[grml-debootstrap.git] / chroot-script
index 470a111..7caf4dd 100755 (executable)
@@ -5,8 +5,9 @@
 # Bug-Reports:   see http://grml.org/bugs/
 # License:       This file is licensed under the GPL v2.
 ################################################################################
-
-set -e # exit on any error
+# GRML_CHROOT_SCRIPT_MARKER - do not remove this line unless you want to keep
+# this script as /bin/chroot-script on your new installed system
+################################################################################
 
 . /etc/debootstrap/config    || exit 1
 . /etc/debootstrap/variables || exit 1
@@ -19,9 +20,11 @@ set -e # exit on any error
 if [ -x /usr/bin/aptitude ] ; then
    APTINSTALL="aptitude -y --without-recommends install $DPKG_OPTIONS"
    APTUPDATE='aptitude update'
+   APTUPGRADE='aptitude -y safe-upgrade'
 else
    APTINSTALL="apt-get --force-yes -y --no-install-recommends install $DPKG_OPTIONS"
    APTUPDATE='apt-get update'
+   APTUPGRADE='apt-get --force-yes -y upgrade'
 fi
 
 if [ -z "$STAGES" ] ; then
@@ -55,31 +58,36 @@ askpass() {
 
 # define chroot mirror {{{
 chrootmirror() {
-  [ -n "$KEEP_SRC_LIST" ] && return
-  [ -z "$COMPONENTS" ]    && COMPONENTS='main contrib non-free'
+  if [ -n "$KEEP_SRC_LIST" ] ; then
+    echo "KEEP_SRC_LIST has been set, skipping chrootmirror stage."
+    return
+  fi
+
+  if [ -z "$COMPONENTS" ] ; then
+    COMPONENTS='main contrib non-free'
+  fi
+  echo "Using repository components $COMPONENTS"
 
   if [ -n "$ISO" ] ; then
-     echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
-     [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
-     # add security.debian.org:
-     case "$RELEASE" in
-       unstable|sid) ;;  # no security pool available
-       *)
-         echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
-         ;;
-     esac
+    echo "Adjusting sources.list for ISO (${ISO})."
+    echo "deb $ISO $RELEASE $COMPONENTS" > /etc/apt/sources.list
+    echo "Adding mirror entry (${MIRROR}) to sources.list."
+    [ -n "$MIRROR" ] && echo "deb $MIRROR $RELEASE $COMPONENTS" >> /etc/apt/sources.list || true
   else
     if [ -n "$MIRROR" ] ; then
-       echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
-       # add security.debian.org:
-       case "$RELEASE" in
-         unstable|sid) ;;  # no security pool available
-         *)
-           echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
-           ;;
-       esac
+      echo "Adjusting sources.list for mirror (${MIRROR})."
+      echo "deb $MIRROR $RELEASE $COMPONENTS" > /etc/apt/sources.list
     fi
   fi
+
+  # add security.debian.org:
+  case "$RELEASE" in
+    unstable|sid) ;;  # no security pool available
+    *)
+      echo "Adding security.debian.org to sources.list."
+      echo "deb http://security.debian.org ${RELEASE}/updates $COMPONENTS" >> /etc/apt/sources.list
+      ;;
+  esac
 }
 # }}}
 
@@ -89,7 +97,6 @@ grmlrepos() {
      # user might have provided their own apt sources.list
      if ! grep -q grml /etc/apt/sources.list.d/grml.list 2>/dev/null ; then
         cat >> /etc/apt/sources.list.d/grml.list << EOF
-
 # grml: stable repository:
   deb     http://deb.grml.org/ grml-stable  main
   deb-src http://deb.grml.org/ grml-stable  main
@@ -97,7 +104,6 @@ grmlrepos() {
 # grml: testing/development repository:
   deb     http://deb.grml.org/ grml-testing main
   deb-src http://deb.grml.org/ grml-testing main
-
 EOF
      fi
 
@@ -111,7 +117,7 @@ EOF
        # why it's necessary, sometimes we get an error even though it works [mika]
      fi
 
-     # make sure we install packages from grml's pool only if not available
+     # make sure we install packages from Grml's pool only if not available
      # from Debian!
      if ! grep -q grml /etc/apt/preferences 2>/dev/null ; then
         cat >> /etc/apt/preferences << EOF
@@ -157,6 +163,18 @@ EOF
 }
 # }}}
 
+# make sure we have an up2date system {{{
+upgrade_system() {
+  if [ "$UPGRADE_SYSTEM" = "yes" ] ; then
+    echo "Running update + upgrade"
+    $APTUPDATE
+    $APTUPGRADE
+  else
+    echo "Not running update + upgrade as \$UPDATE_AND_UPGRADE is not set to 'yes'."
+  fi
+}
+
+# }}}
 # remove now useless apt cache {{{
 remove_apt_cache() {
   if [ "$RM_APTCACHE" = 'yes' ] ; then
@@ -179,7 +197,7 @@ packages() {
 
   if [ "$PACKAGES" = 'yes' ] ; then
      if ! [ -r /etc/debootstrap/packages ] ; then
-       echo "Error: /etc/debootstrap/packages not found, exiting."
+       echo "Error: /etc/debootstrap/packages (inside chroot) not found, exiting." >&2
        exit 1
      else
        $APTUPDATE
@@ -226,9 +244,10 @@ kernel() {
 reconfigure() {
   if [ -n "$RECONFIGURE" ] ; then
      for package in $RECONFIGURE ; do
-         dpkg --list $package 1>/dev/null 2>/dev/null && \
-         DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
-         echo "Warning: $package does not exist, can not reconfigure it."
+         if dpkg --list $package >/dev/null 2>&1 | grep -q '^ii' ; then
+           DEBIAN_FRONTEND=$DEBIAN_FRONTEND dpkg-reconfigure $package || \
+           echo "Warning: $package does not exist, can not reconfigure it."
+         fi
      done
   fi
 }
@@ -237,6 +256,11 @@ reconfigure() {
 # set password of user root {{{
 passwords()
 {
+  if [ -n "$NOPASSWORD" ] ; then
+    echo "Skip setting root password as requested."
+    return 0
+  fi
+
   echo "Activating shadow passwords."
   shadowconfig on
 
@@ -245,7 +269,6 @@ passwords()
      CHPASSWD_OPTION='-m'
   fi
 
-
   if [ -n "$ROOTPASSWORD" ] ; then
      echo root:"$ROOTPASSWORD" | chpasswd $CHPASSWD_OPTION
      export ROOTPASSWORD=''
@@ -342,7 +365,6 @@ fi
 
 cat >> /etc/fstab << EOF
 proc           /proc        proc    defaults                      0   0
-/sys           /sys         sysfs   noauto,rw,nosuid,nodev,noexec 0   0
 /dev/cdrom     /mnt/cdrom0  iso9660 ro,user,noauto                0   0
 # some other examples:
 # /dev/sda2       none         swap    sw,pri=0             0   0
@@ -411,8 +433,13 @@ initrd() {
 grub_install() {
 
   if [ -z "$GRUB" ] ; then
-     echo "Notice: \$GRUB not defined, will not install grub therefore."
-     return 0
+    echo "Notice: \$GRUB not defined, will not install grub inside chroot at this stage."
+    return 0
+  fi
+
+  if ! dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
+    echo "Notice: grub option set but no grub-pc package, installing it therefore."
+    DEBIAN_FRONTEND=$DEBIAN_FRONTEND $APTINSTALL grub-pc
   fi
 
   if ! [ -x "$(which grub-install)" ] ; then
@@ -499,7 +526,7 @@ trap signal_handler HUP INT QUIT TERM
  for i in chrootmirror grmlrepos kernelimg_conf \
      kernel packages extrapackages  reconfigure hosts interfaces \
      timezone fstab hostname initrd grub_install passwords        \
-     custom_scripts remove_apt_cache services ; do
+     custom_scripts upgrade_system remove_apt_cache services ; do
      if stage $i ; then
        $i && stage $i done || exit 1
      fi